pcl::FeatureHandler< FeatureType, DataSet, ExampleIndex > Class Template Referenceabstract

Utility class interface which is used for creating and evaluating features. More...

`#include <pcl/ml/feature_handler.h>`

## Public Member Functions

virtual | ~FeatureHandler ()
| Destructor. More...
virtual void | createRandomFeatures (const size_t num_of_features, std::vector< FeatureType > &features)=0
| Creates random features. More...
virtual void | evaluateFeature (const FeatureType &feature, DataSet &data_set, std::vector< ExampleIndex > &examples, std::vector< float > &results, std::vector< unsigned char > &flags) const =0
| Evaluates a feature on the specified data. More...
virtual void | evaluateFeature (const FeatureType &feature, DataSet &data_set, const ExampleIndex &example, float &result, unsigned char &flag) const =0
| Evaluates a feature on the specified data. More...
virtual void | generateCodeForEvaluation (const FeatureType &feature, ::std::ostream &stream) const =0
| Generates evaluation code for the specified feature and writes it to the specified stream. More...

## Detailed Description

### template<class FeatureType, class DataSet, class ExampleIndex>
class pcl::FeatureHandler< FeatureType, DataSet, ExampleIndex >

Utility class interface which is used for creating and evaluating features.

Definition at line 54 of file feature_handler.h.

## Constructor & Destructor Documentation

## ~FeatureHandler()

template<class FeatureType, class DataSet, class ExampleIndex>

virtual pcl::FeatureHandler< FeatureType, DataSet, ExampleIndex >::~FeatureHandler | ( |  | ) |

inline virtual

Destructor.

Definition at line 60 of file feature_handler.h.

## Member Function Documentation

## createRandomFeatures()

template<class FeatureType, class DataSet, class ExampleIndex>

virtual void pcl::FeatureHandler< FeatureType, DataSet, ExampleIndex >::createRandomFeatures | ( | const size_t | num_of_features,
|  | std::vector< FeatureType > & | features
| ) |  |

pure virtual

Creates random features.

Parameters

  [in] | num_of_features | The number of random features to create.
  [out] | features | The destination for the created features.

Implemented in pcl::ScaledMultiChannel2DComparisonFeatureHandler< DATA_TYPE, NUM_OF_CHANNELS, SCALE_CHANNEL, INVERT_SCALE >, pcl::face_detection::FeatureHandlerDepthAverage< FT, DataSet, ExampleIndex >, and pcl::MultiChannel2DComparisonFeatureHandler< DATA_TYPE, NUM_OF_CHANNELS >.

## evaluateFeature() [1/2]

template<class FeatureType, class DataSet, class ExampleIndex>

virtual void pcl::FeatureHandler< FeatureType, DataSet, ExampleIndex >::evaluateFeature | ( | const FeatureType & | feature,
|  | DataSet & | data_set,
|  | std::vector< ExampleIndex > & | examples,
|  | std::vector< float > & | results,
|  | std::vector< unsigned char > & | flags
| ) |  | const

pure virtual

Evaluates a feature on the specified data.

Parameters

  [in] | feature | The features to evaluate.
  [in] | data_set | The data set on which the feature is evaluated.
  [in] | examples | The examples which specify on which parts of the data set the feature is evaluated.
  [out] | results | The destination for the results of the feature evaluation.
  [out] | flags | Flags that are supplied together with the results.

Implemented in pcl::ScaledMultiChannel2DComparisonFeatureHandler< DATA_TYPE, NUM_OF_CHANNELS, SCALE_CHANNEL, INVERT_SCALE >, pcl::face_detection::FeatureHandlerDepthAverage< FT, DataSet, ExampleIndex >, and pcl::MultiChannel2DComparisonFeatureHandler< DATA_TYPE, NUM_OF_CHANNELS >.

Referenced by pcl::DecisionTreeEvaluator< FeatureType, DataSet, LabelType, ExampleIndex, NodeType >::evaluate(), pcl::FernEvaluator< FeatureType, DataSet, LabelType, ExampleIndex, NodeType >::evaluate(), pcl::FernEvaluator< FeatureType, DataSet, LabelType, ExampleIndex, NodeType >::evaluateAndAdd(), pcl::DecisionTreeEvaluator< FeatureType, DataSet, LabelType, ExampleIndex, NodeType >::evaluateAndAdd(), pcl::FernEvaluator< FeatureType, DataSet, LabelType, ExampleIndex, NodeType >::getNodes(), and pcl::DecisionTreeEvaluator< FeatureType, DataSet, LabelType, ExampleIndex, NodeType >::getNodes().

## evaluateFeature() [2/2]

template<class FeatureType, class DataSet, class ExampleIndex>

virtual void pcl::FeatureHandler< FeatureType, DataSet, ExampleIndex >::evaluateFeature | ( | const FeatureType & | feature,
|  | DataSet & | data_set,
|  | const ExampleIndex & | example,
|  | float & | result,
|  | unsigned char & | flag
| ) |  | const

pure virtual

Evaluates a feature on the specified data.

Parameters

  [in] | feature | The features to evaluate.
  [in] | data_set | The data set on which the feature is evaluated.
  [in] | example | The examples which specify on which parts of the data set the feature is evaluated.
  [out] | result | The destination for the results of the feature evaluation.
  [out] | flag | Flags that are supplied together with the results.

Implemented in pcl::ScaledMultiChannel2DComparisonFeatureHandler< DATA_TYPE, NUM_OF_CHANNELS, SCALE_CHANNEL, INVERT_SCALE >, pcl::face_detection::FeatureHandlerDepthAverage< FT, DataSet, ExampleIndex >, and pcl::MultiChannel2DComparisonFeatureHandler< DATA_TYPE, NUM_OF_CHANNELS >.

## generateCodeForEvaluation()

template<class FeatureType, class DataSet, class ExampleIndex>

virtual void pcl::FeatureHandler< FeatureType, DataSet, ExampleIndex >::generateCodeForEvaluation | ( | const FeatureType & | feature,
|  | ::std::ostream & | stream
| ) |  | const

pure virtual

Generates evaluation code for the specified feature and writes it to the specified stream.

Parameters

  [in] | feature | The feature for which code is generated.
  [out] | stream | The destionation for the code.

Implemented in pcl::face_detection::FeatureHandlerDepthAverage< FT, DataSet, ExampleIndex >.

The documentation for this class was generated from the following file:

- /build/pcl-OilVEB/pcl-1.8.1+dfsg1/ml/include/pcl/ml/feature_handler.h